unit FillGridDelphi0;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

type
  TForm1 = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  x0, y0, dh, dw, w, h : integer;
  pressed  : boolean;
  msButton : TMouseButton;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  x0:=10; y0:=10; dh:=10; dw:=10; w:=40; h:=40;
  pressed := false;
  msButton := TMouseButton(-1);
end;

procedure TForm1.FormPaint(Sender: TObject);
var
   row, col, len, gray : integer;
begin
  gray := 20;
  Form1.Canvas.Pen.Color := RGB(gray, gray, gray);
  len := dw*w;
  for row:=0 to h do
     begin
       Form1.Canvas.MoveTo(x0,     y0+row*dh);
       Form1.Canvas.LineTo(x0+len, y0+row*dh);
     end;
  len := dh*h;
  for col:=0 to w do
     begin
       Form1.Canvas.MoveTo(x0+col*dw, y0    );
       Form1.Canvas.LineTo(x0+col*dw, y0+len);
     end
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  pressed  := true;
  msButton := Button;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   px, py, dr, gray : integer;
begin
  gray := 20;
  dr   := 1;

  if ( not pressed ) then exit;
  if ( (X<x0) or (X>=(x0+dw*w)) or (Y<y0) or (Y>=(y0+dh*h)) ) then exit;
  px := (X-x0) div dw;
  py := (Y-y0) div dh;
  if ( msButton=mbLeft )  then
    begin
      Form1.Canvas.Brush.Color := RGB(gray, gray, gray);
      gray := gray + 50;
    end
  else
    Form1.Canvas.Brush.Color := clWhite;

  Form1.Canvas.Pen.Color := RGB(gray, gray, gray);
  Form1.Canvas.Rectangle(x0+px*dw, y0+py*dh, x0+(px+1)*dw+dr, y0+(py+1)*dh+dr);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  pressed  := false;
  msButton := TMouseButton (-1);
end;

end.
